<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/FEMB_CnC/FEMB_CnC.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_3684d69294c958c8d2d80c5dc939c716.html">FEMB_CnC</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">FEMB_CnC.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="vhdlkeyword">use </span>work.COLDATA_CNC_package.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classFEMB__CnC__IO.html">FEMB_CnC_IO</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div>
<div class="line"><a name="l00007"></a><span class="lineno"><a class="code" href="classFEMB__CnC.html">    7</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classFEMB__CnC.html">FEMB_CnC</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;  <span class="vhdlchar">clk_DUNE</span>        <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;  <span class="vhdlchar">clk_SBND</span>        <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;  <span class="vhdlchar">reset</span>           <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;  <span class="vhdlchar">cmd_convert</span>     <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- pulse</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;  <span class="vhdlchar">cmd_calibrate</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- pulse</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;  <span class="vhdlchar">cmd_sync</span>        <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- pulse</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;  <span class="vhdlchar">cmd_reset</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- pulse  </span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;  <span class="vhdlchar">COLDATA_cmd</span>     <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;  <span class="vhdlchar">COLDATA_clk</span>     <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;  <span class="vhdlchar">COLDATA_cmd_sel</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  <span class="vhdlchar">COLDATA_clk_sel</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  <span class="vhdlchar">monitor</span>         <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">FEMB_CNC_Monitor_t</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;  <span class="vhdlchar">control</span>         <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">FEMB_CNC_Control_t</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;  <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">FEMB_CnC</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="code" href="classFEMB__CnC_1_1FEMB__CnC.html">   24</a></span>&#160;<span class="vhdlkeyword">architecture</span> <a class="code" href="classFEMB__CnC.html">FEMB_CnC</a> <span class="vhdlkeyword">of</span> <a class="code" href="classFEMB__CnC.html">FEMB_CnC</a> is</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classSBND__PWM__CLK__ENCODER.html">SBND_PWM_CLK_ENCODER</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;      RESET         : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;      CLK_100MHz    : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;      SAMPLE_RATE   : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;      EXT_CMD1      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;      EXT_CMD2      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;      EXT_CMD3      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      EXT_CMD4      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;      SW_CMD1       : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;      SW_CMD2       : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;      SW_CMD3       : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;      SW_CMD4       : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;      DIS_CMD1      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;      DIS_CMD2      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;      DIS_CMD3      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;      DIS_CMD4      : <span class="vhdlkeyword">IN</span>  <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;      SBND_SYNC_CMD : <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;      SBND_ADC_CLK  : <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC</span>);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">SBND_PWM_CLK_ENCODER</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classcounter.html">counter</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="vhdlkeyword">generic</span> (</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;      roll_over   : <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      end_value   : <span class="comment">std_logic_vector</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;      start_value : <span class="comment">std_logic_vector</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      DATA_WIDTH  : <span class="comment">integer</span>);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;      clk         : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;      reset_async : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      reset_sync  : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;      enable      : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;      event       : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;      count       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(DATA_WIDTH<span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;      at_max      : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">counter</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">frame_counter</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlkeyword">range</span> <span class="vhdlchar">FRAME_LENGTH</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">FRAME_LENGTH</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">error_convert_timing</span> <span class="vhdlchar">:</span> <span class="comment">std_logic</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="vhdlkeyword">begin </span><span class="keyword"> -- <span class="vhdlkeyword">architecture</span> FEMB_CnC</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="vhdlchar">COLDATA_cmd_sel</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">cmd_sel</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="vhdlchar">COLDATA_clk_sel</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">clk_sel</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">cmd_sel</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">cmd_sel</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">clk_sel</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">clk_sel</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword">  --Hack <span class="vhdlkeyword">for</span> SBND FEMB</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <span class="vhdlchar">COLDATA_clk</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_SBND</span>;  </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  SBND_PWM_CLK_ENCODER_1: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classSBND__PWM__CLK__ENCODER.html">SBND_PWM_CLK_ENCODER</a></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;      RESET          =&gt; reset,</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;      CLK_100MHz     =&gt; clk_SBND,</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;      SAMPLE_RATE    =&gt; x&quot;0&quot;,</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;      EXT_CMD1       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;      EXT_CMD2       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;      EXT_CMD3       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;      EXT_CMD4       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;      SW_CMD1        =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;      SW_CMD2        =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;      SW_CMD3        =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;      SW_CMD4        =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;      DIS_CMD1       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;      DIS_CMD2       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;      DIS_CMD3       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;      DIS_CMD4       =&gt; &#39;0&#39;,</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;      SBND_SYNC_CMD  =&gt; COLDATA_cmd,</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;      SBND_ADC_CLK   =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keyword"></span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keyword">  --Generate stream <span class="vhdlkeyword">for</span> the COLDATA ASICS</span><span class="keyword"></span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword">  --  </span><span class="keyword"></span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">--  COLDATA_cmd_generator: <span class="vhdlkeyword">process</span> (clk_DUNE, reset) <span class="vhdlkeyword">is</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">begin</span>  -- <span class="vhdlkeyword">process</span> COLDATA_cmd_generator</span><span class="keyword"></span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">--    <span class="vhdlkeyword">if</span> reset = &#39;1&#39; <span class="vhdlkeyword">then</span>                 -- asynchronous reset (active high)</span><span class="keyword"></span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">--      COLDATA_CMD &lt;= &#39;0&#39;;</span><span class="keyword"></span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword">--      frame_counter &lt;= FRAME_LENGTH;</span><span class="keyword"></span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keyword">--    <span class="vhdlkeyword">elsif</span> clk_DUNE&#39;event <span class="vhdlkeyword">and</span> clk_DUNE = &#39;1&#39; <span class="vhdlkeyword">then</span>  -- rising clock edge</span><span class="keyword"></span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">--      --EMULATE JACKS FEMB COLDATA FPGA</span><span class="keyword"></span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">--      --Currently this does very little since the COLDATA ASICs don&#39;t exist <span class="vhdlkeyword">and</span> the</span><span class="keyword"></span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">--      --FPGA stand-in lacks this protocol.</span><span class="keyword"></span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">--      --This only generates a 2Mhz clock <span class="vhdlkeyword">to</span> cause the convert signals</span><span class="keyword"></span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">--      error_convert_timing &lt;= &#39;0&#39;;</span><span class="keyword"></span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">--      <span class="vhdlkeyword">if</span> cmd_convert = &#39;1&#39; <span class="vhdlkeyword">then</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">--        frame_counter &lt;= </span><span class="vhdllogic">0</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">--        <span class="vhdlkeyword">if</span> frame_counter /= FRAME_LENGTH -1 <span class="vhdlkeyword">then</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">--          error_convert_timing &lt;= &#39;1&#39;;</span><span class="keyword"></span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keyword">--        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">--      <span class="vhdlkeyword">elsif</span> frame_counter /= FRAME_LENGTH <span class="vhdlkeyword">then</span>        </span><span class="keyword"></span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">--        frame_counter &lt;= frame_counter +1;</span><span class="keyword"></span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keyword">--      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="keyword">--      </span><span class="keyword"></span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keyword">--      <span class="vhdlkeyword">case</span> frame_counter <span class="vhdlkeyword">is</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="keyword">--        <span class="vhdlkeyword">when</span> FRAME_LENGTH/2 <span class="vhdlkeyword">downto</span> </span><span class="vhdllogic">0</span> =&gt;<span class="keyword"></span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword">--          COLDATA_cmd &lt;= &#39;1&#39;;</span><span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">--        <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span> =&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keyword">--          COLDATA_cmd &lt;= &#39;0&#39;;</span><span class="keyword"></span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">--      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keyword">--    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> COLDATA_cmd_generator;</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">  -- Error counter</span><span class="keyword"></span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keyword">  ------------------------------------------------------------------------------- </span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  counter_5: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classcounter.html">counter</a></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;      clk          =&gt; clk_DUNE ,</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;      reset_async  =&gt; reset,</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      reset_sync   =&gt; control.error_convert_timing_counter_reset,</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;      enable       =&gt; &#39;1&#39;,</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;      event        =&gt; error_convert_timing ,</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;      count        =&gt; monitor.error_convert_timing_counter,</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      at_max       =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="keyword">  -- Counters <span class="vhdlkeyword">for</span> FEMB cmds</span><span class="keyword"></span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="keyword">  ------------------------------------------------------------------------------- </span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;  counter_1: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classcounter.html">counter</a></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;      clk          =&gt; clk_DUNE ,</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;      reset_async  =&gt; reset,</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;      reset_sync   =&gt; control.convert_counter_reset,</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;      enable       =&gt; &#39;1&#39;,</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      event        =&gt; cmd_convert ,</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;      count        =&gt; monitor.convert_counter,</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      at_max       =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;  counter_2: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classcounter.html">counter</a></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      clk          =&gt; clk_DUNE ,</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      reset_async  =&gt; reset,</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      reset_sync   =&gt; control.calibrate_counter_reset,</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;      enable       =&gt; &#39;1&#39;,</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;      event        =&gt; cmd_calibrate ,</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;      count        =&gt; monitor.calibrate_counter ,</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;      at_max       =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;  counter_3: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classcounter.html">counter</a></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;      clk          =&gt; clk_DUNE ,</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;      reset_async  =&gt; reset,</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;      reset_sync   =&gt; control.sync_counter_reset ,</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;      enable       =&gt; &#39;1&#39;,</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;      event        =&gt; cmd_sync,</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;      count        =&gt; monitor.sync_counter ,</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;      at_max       =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;  counter_4: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classcounter.html">counter</a></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;      clk          =&gt; clk_DUNE ,</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;      reset_async  =&gt; reset,</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;      reset_sync   =&gt; control.reset_counter_reset ,</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;      enable       =&gt; &#39;1&#39;,</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;      event        =&gt; cmd_reset ,</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;      count        =&gt; monitor.reset_counter ,</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;      at_max       =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">FEMB_CnC</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
